/*
 * linux/include/asm-arm/arch-a5k/hardware.h
 *
 * Copyright (C) 1996 Russell King.
 *
 * This file contains the hardware definitions of the A5000 series machines.
 */

#ifndef __ASM_ARCH_HARDWARE_H
#define __ASM_ARCH_HARDWARE_H

#define HAS_IOC
#define HAS_MEMC1A
#define HAS_PCIO

#ifndef ASSEMBLER

/*
 * IO definitions
 */
#define IOEB_BASE		((volatile unsigned char *)0x03350050)
#define IOC_BASE		((volatile unsigned char *)0x03200000)
#define PCIO_FLOPPYDMABASE	((volatile unsigned char *)0x0302a000)
#define PCIO_BASE		((volatile unsigned char *)0x03010000)

#else

#define IOEB_BASE		0x03350050
#define IOC_BASE		0x03200000
#define PCIO_FLOPPYDMABASE	0x0302a000
#define PCIO_BASE		0x03010000

#endif

/*
 * RAM definitions
 */
#define GET_MEMORY_PHYSICAL	(0x02000000)
#define GET_MEMORY_START	((unsigned long)&_end - 0x01800000 + KERNEL_BASE)
#define GET_MEMORY_END(ps,np)	(GET_MEMORY_PHYSICAL + (ps) * (np))

#define SCREEN_BASE		GET_MEMORY_PHYSICAL
#define PARAMS_BASE		(GET_MEMORY_PHYSICAL + 0x7c000)
#define KERNEL_BASE		(GET_MEMORY_PHYSICAL + 0x80000)

#endif

