/*
 * linux/asm/proc-arm2/assembler.h
 *
 * Copyright (C) 1996 Russell King
 *
 * This file contains arm architecture specific defines
 * for the different processors
 */

#define LOADREGS(cond, base, reglist...)\
	ldm##cond	base,reglist^

#define RETINSTR(instr, regs...)\
	instr##s	regs

#define MODENOP\
	mov	r0, r0

#define SAVEIRQS
#define RESTOREIRQS

#define DISABLEIRQS\
	teqp	pc, #0x08000003

#define ENABLEIRQS\
	teqp	pc, #0x00000003

#define USERMODE\
	teqp	pc, #0x00000000;\
	mov	r0, r0

#define SVCMODE\
	teqp	pc, #0x00000003;\
	mov	r0, r0
