/*
 * linux/include/asm-arm/proc-arm3/hardware.h
 *
 * Copyright (C) 1996 Russell King
 */

#ifndef __ASM_PROC_HARDWARE_H
#define __ASM_PROC_HARDWARE_H

#include <asm/procinfo.h>

#ifndef __ASSEMBLER__
/*
 * Need to setup cache on ARM3, but not the ARM250
 */
extern __inline__ void cache_setup (int features)
{
    if (features & F_CACHE) {
	__asm__ __volatile__("
	mcr	15, 0, %0, c3, c0
	mcr	15, 0, %1, c4, c0
	mcr	15, 0, %2, c5, c0
	mcr	15, 0, %3, c1, c0
	mcr	15, 0, %3, c2, c0
	" : : "r" (0x000e7fff), "r" (0x000e7fff), "r" (0xf0000000), "r" (3));
    } else {
    	extern unsigned long armcache_flush[2];

    	armcache_flush[0] = armcache_flush[1];
    }
}

#endif

#endif

