/*
 * linux/include/asm-arm/proc-arm6/ptrace.h
 *
 * Copyright (C) 1996 Russell King
 */

#ifndef __ASM_PROC_PTRACE_H
#define __ASM_PROC_PTRACE_H

#define USR_MODE	0x10
#define FIQ_MODE	0x11
#define IRQ_MODE	0x12
#define SVC_MODE	0x13
#define ABT_MODE	0x17
#define UND_MODE	0x1B

#define user_mode(regs)	\
	({ unsigned long reg;
	__asm__ __volatile__("\
	mrs	%0, CPSR\n\
	and	%0, %0, #31\n\"
	: "=r" (reg));\
	return reg == USR_MODE; })
	
#define instruction_pointer(regs)	((regs)->ARM_pc)

#endif

